<template>
  <div v-if="factory">
    <h1>{{ factory.name.name }}</h1>
    <p><strong>Location:</strong> {{ factory.name.location.street }}, {{ factory.name.location.city }}, {{ factory.name.location.state }}</p>
    <p><strong>Opening Hours:</strong> {{ factory.name.openingHours }}</p>
    <p><strong>Rating:</strong> {{ factory.name.rating }}</p>
    <!-- Dugme za prikaz komentara -->
    <button class="custom-btn btn-7" @click="viewComments">View Comments</button>
    <!-- Dugme za prikaz radnika -->
    <button v-if="isManager" class="custom-btn btn-7" @click="viewWorkers">View Workers</button>


    <h2>Chocolates</h2>
    <div class="row">
      <div v-for="chocolate in factory.name.chocolates" :key="chocolate.id" class="col-sm-12 col-md-6 col-lg-4 mb-4">
        <div class="card text-dark card-has-bg click-col" :style="{ backgroundImage: 'url(' + getChocolateImagePath(chocolate.image) + ')' }">
          <img class="card-img d-none" :src="getChocolateImagePath(chocolate.image)" :alt="chocolate.name">
          <div class="card-img-overlay d-flex flex-column">
            <div class="card-body">
              <small class="card-meta mb-2">{{ chocolate.chocolateKind }} Chocolate</small>
              <h4 class="card-title mt-0">{{ chocolate.name }}</h4>
              <p class="card-text">{{ chocolate.description }}</p>
              <small><i class="far fa-clock"></i> {{ chocolate.status }}</small>
            </div>
            <div class="card-footer">
              <div class="media">
                <div class="media-body">
                  <h6 class="my-0 text-dark d-block">{{ chocolate.chocolateType }}</h6>
                  <small>Weight: {{ chocolate.weight }}g </small>
                  <small> Price: {{ chocolate.price }} RSD, </small>
                  <small>Quantity: {{ chocolate.quantity }}</small>
                  
                  <!-- Polje za unos količine -->
                  <div class="form-group mt-2">
                    <label v-if="isCustomer" for="quantityInput">Quantity:</label>
                    <input v-if="isCustomer" type="number" v-model="chocolateQuantity[chocolate.name]" :max="chocolate.quantity" min="1" placeholder="Quantity" class="form-control" />
                  </div>
                  
                  <!-- Dugmad za Edit, Delete i dodavanje u korpu -->
                  <button type="button" class="custom-btn btn-7" @click="editChocolate(chocolate)">Edit</button>
                  <button v-if="isManager" type="button" class="custom-btn btn-6-red" @click="deleteChocolate(chocolate)">Delete</button>
                  <button v-if="isCustomer" type="button" class="custom-btn btn-6" @click="addToCart(chocolate)">Add to Cart</button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Button to open the form for adding a new chocolate -->
    <button v-if="isManager" type="button" class="custom-btn btn-6" @click="showAddChocolateForm = true">Add New Chocolate</button>

    <!-- Form for adding/editing a chocolate -->
    <div v-if="showAddChocolateForm || showEditChocolateForm">
      <h2>{{ showAddChocolateForm ? 'Add New Chocolate' : 'Edit Chocolate' }}</h2>
      <form @submit.prevent="validateChocolateForm">
        <div class="form-group">
          <label v-if="isManager" for="name">Name:</label>
          <input v-if="isManager" type="text" v-model="newChocolate.name" class="form-control" required>
          <div v-if="!newChocolate.name && submitted" class="invalid-feedback">Name is required.</div>
        </div>
        <div class="form-group">
          <label v-if="isManager" for="price">Price:</label>
          <input v-if="isManager" type="number" v-model="newChocolate.price" class="form-control" required>
          <div v-if="!newChocolate.price && submitted" class="invalid-feedback">Price is required.</div>
        </div>
        <div class="form-group">
          <label v-if="isManager" for="chocolateKind">Chocolate Kind:</label>
          <input v-if="isManager" type="text" v-model="newChocolate.chocolateKind" class="form-control" required>
          <div v-if="!newChocolate.chocolateKind && submitted" class="invalid-feedback">Chocolate Kind is required.</div>
        </div>
        <div class="form-group">
          <label v-if="isManager" for="chocolateType">Chocolate Type:</label>
          <input v-if="isManager" type="text" v-model="newChocolate.chocolateType" class="form-control" required>
          <div v-if="!newChocolate.chocolateType && submitted" class="invalid-feedback">Chocolate Type is required.</div>
        </div>
        <div class="form-group">
          <label v-if="isManager" for="weight">Weight:</label>
          <input v-if="isManager" type="number" v-model="newChocolate.weight" class="form-control" required>
          <div v-if="!newChocolate.weight && submitted" class="invalid-feedback">Weight is required.</div>
        </div>
        <div class="form-group">
          <label v-if="isManager" for="description">Description:</label>
          <input v-if="isManager" type="text" v-model="newChocolate.description" class="form-control" required>
          <div v-if="!newChocolate.description && submitted" class="invalid-feedback">Description is required.</div>
        </div>
        <div class="form-group">
          <label v-if="isManager" for="image">Image:</label>
          <input v-if="isManager" type="file" @change="onFileChange" class="form-control">
        </div>
        <div class="form-group">
          <label v-if="isManager" for="status">Status:</label>
          <input v-if="isManager" type="text" v-model="newChocolate.status" class="form-control" required>
          <div v-if="!newChocolate.status && submitted" class="invalid-feedback">Status is required.</div>
        </div>
        <div class="form-group">
          <label v-if="isManager || isWorker" for="quantity">Quantity:</label>
          <input v-if="isManager || isWorker" type="number" v-model="newChocolate.quantity" class="form-control" required>
          <div v-if="!newChocolate.quantity && submitted" class="invalid-feedback">Quantity is required.</div>
        </div>
        <button type="submit" class="custom-btn btn-6">{{ showAddChocolateForm ? 'Save' : 'Update' }}</button>
        <button type="button" class="custom-btn btn-6-red" @click="cancelForm">Cancel</button>
      </form>
    </div>

    <!-- Back button -->
    <button type="button" class="custom-btn btn-7" @click="goBack">Back</button>
  </div>
  <div v-else>
    <p>Loading...</p>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'FactoryDetail',
  data() {
    return {
      factory: null,
      showAddChocolateForm: false,
      showEditChocolateForm: false,
      newChocolate: {
        name: '',
        price: 0,
        chocolateKind: '',
        chocolateType: '',
        weight: 0,
        description: '',
        image: '',
        status: '',
        quantity: 0
      },
      chocolateQuantity: {}, // Novo polje za praćenje količine po čokoladi
      isManager: false,
      isWorker: false,
      submitted: false // Dodato za praćenje statusa podnošenja forme
    };
  },
  mounted() {
    this.fetchFactory();
    this.checkRole();
  },
  methods: {
    viewComments() {
      // Navigacija ka stranici sa komentarima i slanje factoryId kao parametar
      this.$router.push({ name: 'ViewComments', params: { factoryId: this.factory.id } });
    },
    viewWorkers() {
      this.$router.push({ name: 'ViewWorkers', params: { factoryId: this.factory.id } });  // Navigacija ka stranici sa radnicima
    },
    checkRole() {
      const user = JSON.parse(localStorage.getItem('user'));
      if (user && user === 'Radnik') {
        this.isWorker = true;
      } else if (user && user === 'Menadzer') {
        this.isManager = true;
      }
        else if (user && user === 'Kupac') {
        this.isCustomer = true;
      }
    },
    fetchFactory() {
      const factoryId = this.$route.params.id;
      axios.get(`http://localhost:3000/factories/${factoryId}`)
        .then(response => {
          this.factory = response.data;
          // Osvežite podatke na frontend-u
          this.$forceUpdate();  // Ručno osvežavanje Vue komponente
        })
        .catch(error => {
          console.error("Error fetching factory", error);
        });
    },
    onFileChange(event) {
      const file = event.target.files[0];
      this.newChocolate.image = file ? file.name : '';
    },
    validateChocolateForm() {
      this.submitted = true;
      if (this.newChocolate.name && this.newChocolate.price && this.newChocolate.chocolateKind && this.newChocolate.chocolateType && this.newChocolate.weight && this.newChocolate.description && this.newChocolate.status && this.newChocolate.quantity) {
        if (this.showAddChocolateForm) {
          this.addChocolate();
        } else {
          this.updateChocolate();
        }
      }
    },
    addChocolate() {
      this.factory.name.chocolates.push(this.newChocolate);
      this.updateFactory();
    },
    editChocolate(chocolate) {
      this.newChocolate = { ...chocolate };
      this.showAddChocolateForm = false;
      this.showEditChocolateForm = true;
    },
    updateChocolate() {
      const index = this.factory.name.chocolates.findIndex(c => c.name === this.newChocolate.name);
      if (index !== -1) {
        this.factory.name.chocolates.splice(index, 1, this.newChocolate);
        this.updateFactory();
      }
    },
    deleteChocolate(chocolate) {
      const index = this.factory.name.chocolates.findIndex(c => c.name === chocolate.name);
      if (index !== -1) {
        this.factory.name.chocolates.splice(index, 1);
        this.updateFactory();
      }
    },
addToCart(chocolate) {
  const quantity = parseInt(this.chocolateQuantity[chocolate.name]);

  console.log('Pokušavam da dodam čokoladu u korpu:', chocolate.name, 'Količina:', quantity);

  // Proveri da li je uneta količina manja ili jednaka količini na zalihama
  if (quantity > chocolate.quantity) {
    alert(`Ne možete dodati više od ${chocolate.quantity} jedinica čokolade ${chocolate.name}.`);
    return;
  }

  // Ažuriraj zalihe čokolade
  chocolate.quantity -= quantity;
  console.log('Nove zalihe čokolade:', chocolate.quantity);

  // Dodaj u korpu na serveru sa svim informacijama o čokoladi
  axios.post(`http://localhost:3000/carts/add-to-cart`, {
    username: JSON.parse(localStorage.getItem('fulluser')).username,
    chocolateId: chocolate.id,
    name: chocolate.name,
    price: chocolate.price,
    image: chocolate.image,
    quantity: quantity
  })
  .then(response => {
    console.log("Čokolada uspešno dodata u korpu", response.data);
    alert(`${quantity} jedinica čokolade ${chocolate.name} je dodato u korpu!`);
    // Ovde možete dodati ručno osvežavanje korpe ili neki signal ka komponenti koja upravlja korpom
  })
  .catch(error => {
    console.error("Greška pri dodavanju čokolade u korpu", error);
  });

  // Eventualno ažurirajte stanje na serveru, ako je potrebno
  this.updateChocolateQuantity(chocolate);
},

  // Primer metode za ažuriranje zaliha na serveru
  updateChocolateQuantity(chocolate) {
  console.log('Ažuriranje količine čokolade na serveru:', chocolate.name, 'Nova količina:', chocolate.quantity);

  axios.put(`http://localhost:3000/chocolates/${chocolate.id}`, {
    quantity: chocolate.quantity
  })
  .then(response => {
    console.log("Količina uspešno ažurirana na serveru", response.data);
  })
  .catch(error => {
    console.error("Greška pri ažuriranju količine na serveru", error);
  });
},
    updateFactory() {
      axios.put(`http://localhost:3000/factories/${this.factory.id}`, this.factory)
        .then(response => {
          this.fetchFactory();
          this.showAddChocolateForm = false;
          this.showEditChocolateForm = false;
          this.resetChocolateForm();
        })
        .catch(error => {
          console.error("Error updating factory", error);
        });
    },
    cancelForm() {
      this.showAddChocolateForm = false;
      this.showEditChocolateForm = false;
      this.resetChocolateForm();
    },
    resetChocolateForm() {
      this.newChocolate = {
        name: '',
        price: 0,
        chocolateKind: '',
        chocolateType: '',
        weight: 0,
        description: '',
        image: '',
        status: '',
        quantity: 0
      };
      this.submitted = false; // Resetovanje statusa podnošenja forme
    },
    getChocolateImagePath(image) {
      const images = import.meta.glob('../assets/*.{jpg,png,jpeg}');
      const imageName = image.split('/').pop();
      for (const path in images) {
        if (path.includes(imageName)) {
          return path.replace('../assets', '/src/assets');
        }
      }
      console.error("Error loading chocolate image");
      return '/src/assets/default-chocolate.png';
    },
    goBack() {
      this.$router.push({ name: 'home' });
    }
  }
};
</script>

<style scoped>
@import url('https://fonts.googleapis.com/css2?family=Open+Sans:wght@400;600&display=swap');

body {
  background: #161616;
}

/* Stil za naslov fabrike */
h1 {
    font-size: 2.5rem;  /* Povećan font */
    font-weight: bold;
    color: #FF6A00;  /* Narandžasta boja */
    text-shadow: 1px 1px 2px #000000; /* Blagi senka za efekat dubine */
    margin-bottom: 20px;
}

/* Stil za paragraf sa informacijama */
p {
    font-size: 1.2rem;
    color: #333;  /* Tamnija siva za bolji kontrast */
    margin-bottom: 10px; /* Razmak između elemenata */
}

/* Stil za "strong" tekst unutar paragrafa */
p strong {
    font-weight: bold;
    color: #FF6A00;  /* Narandžasta boja za ključne reči */
}

/* Stil za podnaslov "Chocolates" */
h2 {
    font-size: 2rem;
    font-weight: bold;
    color: #333;
    margin-top: 30px;
    margin-bottom: 15px;
    border-bottom: 2px solid #FF6A00;  /* Linija ispod naslova */
    padding-bottom: 5px;
}

.lead {
  color: #aaa;
}

.wrapper {
  display: flex;
  justify-content: center;
  align-items: center;
  min-height: 100vh;
}

.container {
  background: #fff;
  padding: 20px;
  border-radius: 8px;
  box-shadow: 0 0 20px rgba(0,0,0,0.1);
}

.card {
  border: none;
  transition: all 500ms cubic-bezier(0.19, 1, 0.22, 1);
  overflow: hidden;
  border-radius: 20px;
  min-height: 500px;
  box-shadow: 0 0 12px 0 rgba(0, 0, 0, 0.2);

  @media (max-width: 768px) {
    min-height: 400px;
  }

  @media (max-width: 420px) {
    min-height: 350px;
  }

  &.card-has-bg {
    transition: all 500ms cubic-bezier(0.19, 1, 0.22, 1);
    background-size: cover;
    background-repeat: no-repeat;
    background-position: center center;
    &:before {
      content: '';
      position: absolute;
      top: 0;
      right: 0;
      bottom: 0;
      left: 0;
      background: inherit;
      -webkit-filter: grayscale(1);
      -moz-filter: grayscale(100%);
      -ms-filter: grayscale(100%);
      -o-filter: grayscale(100%);
      filter: grayscale(100%);
    }

    &:hover {
      transform: scale(0.98);
      box-shadow: 0 0 5px -2px rgba(0, 0, 0, 0.3);
      background-size: 50%;
      transition: all 500ms cubic-bezier(0.19, 1, 0.22, 1);

      .card-img-overlay {
        transition: all 800ms cubic-bezier(0.19, 1, 0.22, 1);
        background: rgb(255,186,33);
        background: linear-gradient(0deg, rgba(255,186,33,0.5) 0%, rgba(255,186,33,1) 100%);
      }
    }
  }
  
  .card-footer {
    background: none;
    border-top: none;

    .media img {
      border: solid 3px rgba(255, 255, 255, 0.3);
    }
  }

  .card-title {
    font-weight: 800;
  }

  .card-meta {
    color: rgba(0, 0, 0, 0.3);
    text-transform: uppercase;
    font-weight: 500;
    letter-spacing: 2px;
  }

  .card-body {
    transition: all 500ms cubic-bezier(0.19, 1, 0.22, 1);
  }

  &:hover .card-body {
    margin-top: 30px;
    transition: all 800ms cubic-bezier(0.19, 1, 0.22, 1);
  }

  cursor: pointer;
  transition: all 800ms cubic-bezier(0.19, 1, 0.22, 1);

  .card-img-overlay {
    transition: all 800ms cubic-bezier(0.19, 1, 0.22, 1);
    background: rgb(255,186,33);
    background: linear-gradient(0deg, rgba(255,186,33,0.3785889355742297) 0%, rgba(255,186,33,1) 100%);
  }
}

.logo {
  width: 30px;
  height: 30px;
}

.search-filters {
  margin-bottom: 20px;
}

.search-filters input,
.search-filters select {
  margin-right: 10px;
  margin-bottom: 10px;
}

.btn-rounded {
  border-radius: 50px;
}

.form-group {
  margin-bottom: 15px;
}

.invalid-feedback {
  color: red;
  font-size: 0.875em;
}

button {
  margin: 10px;
}
.custom-btn {
  width: 180px;
  height: 40px;
  color: #fff;
  border-radius: 5px;
  padding: 10px 25px;
  font-family: 'Lato', sans-serif;
  font-weight: 500;
  background: transparent;
  cursor: pointer;
  transition: all 0.3s ease;
  position: relative;
  display: inline-block;
  box-shadow: inset 2px 2px 2px 0px rgba(255,255,255,.5),
              7px 7px 20px 0px rgba(0,0,0,.1),
              4px 4px 5px 0px rgba(0,0,0,.1);
  outline: none;
}

/* 7 */
.btn-7 {
  background: linear-gradient(0deg, rgba(255,151,0,1) 0%, rgba(251,75,2,1) 100%);
  line-height: 42px;
  padding: 0;
  border: none;
}
.btn-7 span {
  position: relative;
  display: block;
  width: 100%;
  height: 100%;
}
.btn-7:before,
.btn-7:after {
  position: absolute;
  content: "";
  right: 0;
  bottom: 0;
  background: rgba(251,75,2,1);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-7:before {
  height: 0%;
  width: 2px;
}
.btn-7:after {
  width: 0%;
  height: 2px;
}
.btn-7:hover {
  color: rgba(251,75,2,1);
  background: transparent;
}
.btn-7:hover:before {
  height: 100%;
}
.btn-7:hover:after {
  width: 100%;
}
.btn-7 span:before,
.btn-7 span:after {
  position: absolute;
  content: "";
  left: 0;
  top: 0;
  background: rgba(251,75,2,1);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-7 span:before {
  width: 2px;
  height: 0%;
}
.btn-7 span:after {
  height: 2px;
  width: 0%;
}
.btn-7 span:hover:before {
  height: 100%;
}
.btn-7 span:hover:after {
  width: 100%;
}

/* 6 - Zeleno dugme */
.btn-6 {
  background: linear-gradient(0deg, rgb(42, 156, 43) 0%, rgb(81, 246, 4) 100%);
  line-height: 42px;
  padding: 0;
  border: none;
  color: white;
  border-radius: 5px;
  cursor: pointer;
  position: relative;
  display: inline-block;
  transition: all 0.3s ease;
}
.btn-6 span {
  position: relative;
  display: block;
  width: 100%;
  height: 100%;
}
.btn-6:before,
.btn-6:after {
  position: absolute;
  content: "";
  right: 0;
  bottom: 0;
  background: rgb(35, 251, 2);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6:before {
  height: 0%;
  width: 2px;
}
.btn-6:after {
  width: 0%;
  height: 2px;
}
.btn-6:hover {
  color: rgb(87, 198, 109);
  background: transparent;
}
.btn-6:hover:before {
  height: 100%;
}
.btn-6:hover:after {
  width: 100%;
}
.btn-6 span:before,
.btn-6 span:after {
  position: absolute;
  content: "";
  left: 0;
  top: 0;
  background: rgb(2, 251, 139);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6 span:before {
  width: 2px;
  height: 0%;
}
.btn-6 span:after {
  height: 2px;
  width: 0%;
}
.btn-6 span:hover:before {
  height: 100%;
}
.btn-6 span:hover:after {
  width: 100%;
}

/* 6 - Crveno dugme */
.btn-6-red {
  background: linear-gradient(0deg, rgb(220, 53, 69) 0%, rgb(255, 107, 114) 100%);
  line-height: 42px;
  padding: 0;
  border: none;
  color: white;
  border-radius: 5px;
  cursor: pointer;
  position: relative;
  display: inline-block;
  transition: all 0.3s ease;
}
.btn-6-red span {
  position: relative;
  display: block;
  width: 100%;
  height: 100%;
}
.btn-6-red:before,
.btn-6-red:after {
  position: absolute;
  content: "";
  right: 0;
  bottom: 0;
  background: rgb(255, 80, 80);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6-red:before {
  height: 0%;
  width: 2px;
}
.btn-6-red:after {
  width: 0%;
  height: 2px;
}
.btn-6-red:hover {
  color: rgb(255, 150, 150);
  background: transparent;
}
.btn-6-red:hover:before {
  height: 100%;
}
.btn-6-red:hover:after {
  width: 100%;
}
.btn-6-red span:before,
.btn-6-red span:after {
  position: absolute;
  content: "";
  left: 0;
  top: 0;
  background: rgb(255, 80, 80);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6-red span:before {
  width: 2px;
  height: 0%;
}
.btn-6-red span:after {
  height: 2px;
  width: 0%;
}
.btn-6-red span:hover:before {
  height: 100%;
}
.btn-6-red span:hover:after {
  width: 100%;
}

</style>
